# Eva-Pro_Test-stend
Стенд для проверки и колибровки датчиков.
# Подготовка

## Настройка raspi-config

1. Открыть настройки
```
sudo raspi-config
```
2. Меню Interface Options
3. Выбрать пункт SPI
4. Yes/Да

## Включить IPv4
Изначально советую включить IPv4 Инструкция:

Создать файл:
```
sudo nano /etc/apt/apt.conf.d/99force-ipv4
```

Вставить в него 
```
Acquire::ForceIPv4 "true";
```

Либо при установки пакетов установить флаг  `-o Acquire::ForceIPv4=true`

Пример:
```
sudo apt update -o Acquire::ForceIPv4=true
```

Без этого пакеты будут пытаться скачиваться через IPv6, поэтому ни один пакет не будет установлен.

## Установка VS Code
```
sudo apt update
sudo apt upgrade
sudo apt install -y wget gpg
wget -qO- https://packages.microsoft.com/keys/microsoft.asc | gpg --dearmor > microsoft.gpg
sudo install -o root -g root -m 644 microsoft.gpg /usr/share/keyrings/
sudo sh -c 'echo "deb [arch=armhf signed-by=/usr/share/keyrings/microsoft.gpg] https://packages.microsoft.com/repos/code stable main" > /etc/apt/sources.list.d/vscode.list'
rm -f microsoft.gpg
sudo apt update
sudo apt install code
```
## Установка cURL
```
sudo apt update
sudo apt install -y  libcurl4-openssl-dev
```
## Установка GTK
### Установка библиотеки
```
sudo apt install -y libcairo2-dev libpango1.0-dev libatk1.0-dev libgdk-pixbuf2.0-dev
sudo apt install -y libgtk-3-dev
```

### Использование для vscode
Будет работать и без этого, но VS code будет выводить ошибку что не может найти файл в библиотеки. 

В папке `.vscode\` в файле `c_cpp_properties.json` указать пути до gtk пример.
```json
{
    "configurations": [
      {
        "name": "Linux",
        "includePath": [
          "${workspaceFolder}/**",
          "/usr/include/gtk-3.0",
          "/usr/include/glib-2.0",
          "/usr/lib/arm-linux-gnueabihf/glib-2.0/include",
          "/usr/include/cairo",
          "/usr/include/pango-1.0",
          "/usr/include/gdk-pixbuf-2.0",
          "/usr/include/atk-1.0",
          "/usr/include/harfbuzz/"
        ],
        "defines": [],
        "compilerPath": "/usr/bin/gcc",
        "cStandard": "c11",
        "cppStandard": "c++17",
        "intelliSenseMode": "linux-gcc-x64"
      }
    ],
    "version": 4
}
``` 

Если путь подчёркивается (не существует). После поиска заменить путь на существующий.
```
find /usr -name <Имя файла который нужно найти>.h
```
## Установка WiringPi
```
sudo apt install git
git clone https://github.com/WiringPi/WiringPi.git
cd WiringPi
./build
cd ..
```
### Проверка
```
gpio readall
```

# Usage

Для компиляции и запуска программы
```
make
```

